a2_password_check_equality = (function () {
  return function (id1, id2) {
    $(function () {
      function check_equality() {
        setTimeout(function () {
          var $help_text = $input2.parent().find(".hint");
          var password1 = $input1.val();
          var password2 = $input2.val();

          if (!password2) {
            $help_text.removeClass("a2-password-nok");
            $help_text.removeClass("a2-password-ok");
          } else {
            var equal = password1 == password2;
            $help_text.toggleClass("a2-password-ok", equal);
            $help_text.toggleClass("a2-password-nok", !equal);
          }
        }, 0);
      }
      var $input1 = $("#" + id1);
      var $input2 = $("#" + id2);
      $input1.on("input", check_equality);
      $input2.on("input", check_equality);
    });
  };
})();

a2_password_validate = (function () {
  function get_validation($input) {
    var password = $input.val();
    var $feedback = $input.parent().find(".a2-password-feedback");
    var $hint = $feedback.find(".a2-password-hint");
    var $hint_content = $hint.find("ul");
    var $strength = $feedback.find(".a2-password-strength");

    $.ajax({
      method: "POST",
      url: "/api/validate-password/",
      data: JSON.stringify({ password: password }),
      dataType: "json",
      contentType: "application/json; charset=utf-8",
      success: function (data) {
        strength = Math.round((data.guesses_log10 * 5) / 20) - 1;
        ok = data.errors.length == 0;
        $hint.toggleClass("a2-password-ok", ok);
        $hint.toggleClass("a2-password-hidden", password == "" || strength == 4);
        $hint.toggleClass("errornotice", !ok);
        $hint.toggleClass("infonotice", ok);

        $hint_content.html("");
        if (data.suggestions) data.errors = data.errors.concat(data.suggestions);
        if (data.errors.length > 0) {
          $(data.errors).each(function (idx, msg) {
            $hint_content.append($("<li>").text(msg));
          });
          $hint.css("display", "block");
        } else {
          $hint.css("display", "none");
        }

        for (var i = 0; i < 5; ++i) {
          $strength.removeClass("strength-" + i);
        }

        $strength.addClass("strength-" + strength);
        $feedback.css("display", "block");
      },
    });
  }

  return function (id) {
    var $input = $("#" + id);

    function validate_password() {
      setTimeout(function () {
        get_validation($input);
      }, 0);
    }

    $input.on("input.a2-password-validate", validate_password);

    const $parent_form = $input.parents("form");
    const $user_inputs = $parent_form.find("input[data-password-strength-input]");
    $user_inputs.on("input.a2-password-validate", validate_password);
  };
})();

// vim: tabstop=4 shiftwidth=4 softtabstop=4 expandtab
